/*
 * ,m6Y=,:.gM##Od###a,:?"DGK   Generalitat de Catalunya
 * .#J=.dNJ7M#F` H#P!JMx,T?b
 * J1!.M##  M#F  #Hr ,##N,iW
 * J!d3H##  M#F  ##r ,##L4,?   CTTI
 *  .t\d##` M#F  ##r ,#H:lH,   Canigo
 * .#` d##  MHF` #Hr ,##:,,b
 * .Fr d##  M#F  ##r ,#H: cN   http://www.gencat.net/
 * ,F\ d##  M#F  ##r ,##: l#
 * .Nj d##  M#F` #Hr ,##:.+F
 *  Xc;d##` MHF  ##r ,##:2d!   Aquest codi s propietat de la Generalitat de
 * ,.W,d##  M#F  ##r ,##2J$.   Catalunya. La seva distribuci est prohibida
 * JJ,4H##  M#F` ##r`,##d3`J   sense el seu consentiment
 * ,N..?M#1.M#F  #HL.w#Y...F
 * .@Ja,:,TWM##1O##NT".?.sJK   2007, Tots els drets reservats
 */
package net.gencat.ctti.canigo.samples.prototip.model.base;

import java.io.Serializable;

import java.lang.Comparable;


/**
 * This is an object that contains data related to the CATEGORY table.
 * Do not modify this class because it will be overwritten if the configuration file
 * related to this class is modified.
 *
 * @hibernate.class
 *  table="CATEGORY"
 */
public abstract class BaseCategory implements Comparable, Serializable {
   /**
    * Documentaci.
    */
   public static String REF = "Category";

   /**
    * Documentaci.
    */
   public static String PROP_DESCN = "descn";

   /**
    * Documentaci.
    */
   public static String PROP_NAME = "name";

   /**
    * Documentaci.
    */
   public static String PROP_ID = "id";

   /**
    * Documentaci.
    */
   private java.lang.String descn;

   // primary key
   /**
    * Documentaci.
    */
   private java.lang.String id;

   // fields
   /**
    * Documentaci.
    */
   private java.lang.String name;

   // collections
   /**
    * Documentaci.
    */
   private java.util.Set products;

   /**
    * Documentaci.
    */
   private int hashCode = Integer.MIN_VALUE;

   // constructors
   /**
    * Creates a new BaseCategory object.
    */
   public BaseCategory() {
      initialize();
   }

   /**
    * Constructor for primary key
    */
   public BaseCategory(java.lang.String id) {
      this.setId(id);
      initialize();
   }

   /**
    * Documentaci.
    */
   protected void initialize() {
   }

   /**
    * Return the unique identifier of this class
   * @hibernate.id
   *  generator-class="assigned"
   *  column="CATID"
   */
   public java.lang.String getId() {
      return id;
   }

   /**
    * Set the unique identifier of this class
    * @param id the new ID
    */
   public void setId(java.lang.String id) {
      this.id = id;
      this.hashCode = Integer.MIN_VALUE;
   }

   /**
    * Return the value associated with the column: NAME
    */
   public java.lang.String getName() {
      return name;
   }

   /**
    * Set the value related to the column: NAME
    * @param name the NAME value
    */
   public void setName(java.lang.String name) {
      this.name = name;
   }

   /**
    * Return the value associated with the column: DESCN
    */
   public java.lang.String getDescn() {
      return descn;
   }

   /**
    * Set the value related to the column: DESCN
    * @param descn the DESCN value
    */
   public void setDescn(java.lang.String descn) {
      this.descn = descn;
   }

   /**
    * Return the value associated with the column: products
    */
   public java.util.Set getProducts() {
      return products;
   }

   /**
    * Set the value related to the column: products
    * @param products the products value
    */
   public void setProducts(java.util.Set products) {
      this.products = products;
   }

   /**
    * Documentaci.
    *
    * @param product Documentaci
    */
   public void addToproducts(
      net.gencat.ctti.canigo.samples.prototip.model.Product product) {
      if (null == getProducts()) {
         setProducts(new java.util.TreeSet());
      }

      getProducts().add(product);
   }

   /**
    * Documentaci.
    *
    * @param obj Documentaci
    *
    * @return Documentaci
    */
   public boolean equals(Object obj) {
      if (null == obj) {
         return false;
      }

      if (!(obj instanceof net.gencat.ctti.canigo.samples.prototip.model.Category)) {
         return false;
      } else {
         net.gencat.ctti.canigo.samples.prototip.model.Category category = (net.gencat.ctti.canigo.samples.prototip.model.Category) obj;

         if ((null == this.getId()) || (null == category.getId())) {
            return false;
         } else {
            return (this.getId().equals(category.getId()));
         }
      }
   }

   /**
    * Documentaci.
    *
    * @return Documentaci
    */
   public int hashCode() {
      if (Integer.MIN_VALUE == this.hashCode) {
         if (null == this.getId()) {
            return super.hashCode();
         } else {
            String hashStr = this.getClass().getName() + ":" +
               this.getId().hashCode();
            this.hashCode = hashStr.hashCode();
         }
      }

      return this.hashCode;
   }

   /**
    * Documentaci.
    *
    * @param obj Documentaci
    *
    * @return Documentaci
    */
   public int compareTo(Object obj) {
      if (obj.hashCode() > hashCode()) {
         return 1;
      } else if (obj.hashCode() < hashCode()) {
         return -1;
      } else {
         return 0;
      }
   }

   /**
    * Documentaci.
    *
    * @return Documentaci
    */
   public String toString() {
      return super.toString();
   }
}
