package net.gencat.ctti.canigo.samples.prototip.struts.action;

import net.gencat.ctti.canigo.samples.prototip.model.Category;
import net.gencat.ctti.canigo.samples.prototip.model.bo.CategoryBO;
import net.gencat.ctti.canigo.services.web.lists.ValueListActionHelper;
import net.gencat.ctti.canigo.services.web.struts.DispatchActionSupport;
import net.gencat.ctti.canigo.services.web.struts.SpringBindingActionForm;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

public class TestAction extends DispatchActionSupport {

	private CategoryBO bo;

	private ValueListActionHelper valueListActionHelper;

	public ActionForward search(ActionMapping mapping, ActionForm form,
			javax.servlet.http.HttpServletRequest request,
			javax.servlet.http.HttpServletResponse response) throws Exception {
		valueListActionHelper.search(mapping, form, request, response);

		return mapping.findForward("list");
	}
	
	public ActionForward editList(ActionMapping mapping, ActionForm form,
			javax.servlet.http.HttpServletRequest request,
			javax.servlet.http.HttpServletResponse response) throws Exception {
		valueListActionHelper.search(mapping, form, request, response);

		return mapping.findForward("editList");
	}

	public ActionForward save(ActionMapping mapping, ActionForm form,
			javax.servlet.http.HttpServletRequest request,
			javax.servlet.http.HttpServletResponse response) throws Exception {
		SpringBindingActionForm actionForm = (SpringBindingActionForm) form;
		Category vo = (Category) actionForm.getTarget();

		if (vo.getId() != null) {
			bo.saveOrUpdate(vo);
		}

		return mapping.findForward("success");
	}

	/**
	 * Mtode com per a tots els tests basats en la edici de categories
	 * @param form
	 * @throws Exception
	 */
	private void commonEdit(ActionForm form) throws Exception {
		SpringBindingActionForm actionForm = (SpringBindingActionForm) form;
	      Category vo = (Category) actionForm.getTarget();

	      if (vo.getId() != null) {
	         bo.refresh(vo);
	      }
	}

	/**
	 * Documentaci.
	 *
	 * @param mapping Documentaci
	 * @param form Documentaci
	 * @param request Documentaci
	 * @param response Documentaci
	 * 
	 * @return Documentaci
	 * 
	 * @throws Exception Documentaci
	 */
	public ActionForward edit(ActionMapping mapping, ActionForm form,
			javax.servlet.http.HttpServletRequest request,
			javax.servlet.http.HttpServletResponse response)
	throws Exception {
		// Mtode com per als tests dedici de categories
		commonEdit(form);

		return mapping.findForward("edit");
	}

	/**
	 * Documentaci.
	 *
	 * @param mapping Documentaci
	 * @param form Documentaci
	 * @param request Documentaci
	 * @param response Documentaci
	 * 
	 * @return Documentaci
	 * 
	 * @throws Exception Documentaci
	 */
	public ActionForward editSelectTag(ActionMapping mapping, ActionForm form,
			javax.servlet.http.HttpServletRequest request,
			javax.servlet.http.HttpServletResponse response)
	throws Exception {
		// Mtode com per als tests dedici de categories
		commonEdit(form);

		return mapping.findForward("editSelectTag");
	}

	/**
	 * Documentaci.
	 *
	 * @param mapping Documentaci
	 * @param form Documentaci
	 * @param request Documentaci
	 * @param response Documentaci
	 * 
	 * @return Documentaci
	 * 
	 * @throws Exception Documentaci
	 */
	public ActionForward editAutoCompleteTag(ActionMapping mapping, ActionForm form,
			javax.servlet.http.HttpServletRequest request,
			javax.servlet.http.HttpServletResponse response)
	throws Exception {
		// Mtode com per als tests dedici de categories
		commonEdit(form);

		return mapping.findForward("editAutoCompleteTag");
	}

	public CategoryBO getBo() {
		return bo;
	}

	public void setBo(CategoryBO bo) {
		this.bo = bo;
	}

	public ValueListActionHelper getValueListActionHelper() {
		return valueListActionHelper;
	}

	public void setValueListActionHelper(
			ValueListActionHelper valueListActionHelper) {
		this.valueListActionHelper = valueListActionHelper;
	}

}
