/*
 * ,m6Y=,:.gM##Od###a,:?"DGK   Generalitat de Catalunya
 * .#J=.dNJ7M#F` H#P!JMx,T?b
 * J1!.M##  M#F  #Hr ,##N,iW
 * J!d3H##  M#F  ##r ,##L4,?   CTTI
 *  .t\d##` M#F  ##r ,#H:lH,   Canigo
 * .#` d##  MHF` #Hr ,##:,,b
 * .Fr d##  M#F  ##r ,#H: cN   http://www.gencat.net/
 * ,F\ d##  M#F  ##r ,##: l#
 * .Nj d##  M#F` #Hr ,##:.+F
 *  Xc;d##` MHF  ##r ,##:2d!   Aquest codi s propietat de la Generalitat de
 * ,.W,d##  M#F  ##r ,##2J$.   Catalunya. La seva distribuci est prohibida
 * JJ,4H##  M#F` ##r`,##d3`J   sense el seu consentiment
 * ,N..?M#1.M#F  #HL.w#Y...F
 * .@Ja,:,TWM##1O##NT".?.sJK   2007, Tots els drets reservats
 */
package net.gencat.ctti.canigo.samples.prototip.web.spring.view.document;

import java.util.List;
import java.util.Map;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.gencat.ctti.canigo.services.xml.XMLSerializationService;
import net.gencat.ctti.canigo.services.xml.exception.XMLSerializationServiceException;

import org.springframework.web.servlet.view.AbstractView;


/**
 * Documentaci.
 *
 * @author $author$
 * @version $Revision: 1.2 $
  */
public class XMLView extends AbstractView {
   /**
    * Documentaci.
    */
   public static String XML_LIST = "__list__";

   /**
    * Documentaci.
    */
   public static String XML_SERIALIZATION_SERVICE = "__serializationService__";

   /**
    * Documentaci.
    */
   private static org.apache.log4j.Logger log = org.apache.log4j.Logger.getLogger(XMLView.class);

   /**
    * Creates a new XMLView object.
    */
   public XMLView() {
      setContentType("application/xml");
   }

   /**
    * Documentaci.
    *
    * @param model Documentaci
    * @param request Documentaci
    * @param response Documentaci
    *
    * @throws Exception Documentaci
    * @throws XMLSerializationServiceException Documentaci
    */
   protected void renderMergedOutputModel(Map model,
      HttpServletRequest request, HttpServletResponse response)
      throws Exception {
      List list = (List) request.getAttribute(XML_LIST);
      XMLSerializationService serService = (XMLSerializationService) request.getAttribute(XML_SERIALIZATION_SERVICE);
      ;
      log.debug("Se ha encontrado el servicio?" + (serService != null));
      log.debug("Se ha encontrado la lista?" + (list != null));

      if (list == null) {
         String[] args = new String[] {
               request.getContextPath(), request.getRequestURL().toString(),
               request.getQueryString()
            };
         throw new XMLSerializationServiceException("canigo.samples.prototip.noList2Serialize",
            args);
      }

      if (serService == null) {
         String[] args = new String[] {
               request.getContextPath(), request.getRequestURL().toString(),
               request.getQueryString()
            };
         throw new XMLSerializationServiceException("canigo.samples.prototip.noXMLSerializationSerialize",
            args);
      }

      response.addHeader("Content-Disposition", "attachment; filename=file.xml");

      // aqu escribo el xml
      // Write content type and also length (determined via byte array).
      String xml = serService.toXML(list);
      response.setContentType(getContentType());
      response.setContentLength(xml.getBytes().length);

      // Flush byte array to servlet output stream.
      ServletOutputStream out = response.getOutputStream();
      out.write(xml.getBytes());
      out.flush();
   }
}
