/*
 * ,m6Y=,:.gM##Od###a,:?"DGK   Generalitat de Catalunya
 * .#J=.dNJ7M#F` H#P!JMx,T?b
 * J1!.M##  M#F  #Hr ,##N,iW
 * J!d3H##  M#F  ##r ,##L4,?   CTTI
 *  .t\d##` M#F  ##r ,#H:lH,   Canigo
 * .#` d##  MHF` #Hr ,##:,,b
 * .Fr d##  M#F  ##r ,#H: cN   http://www.gencat.net/
 * ,F\ d##  M#F  ##r ,##: l#
 * .Nj d##  M#F` #Hr ,##:.+F
 *  Xc;d##` MHF  ##r ,##:2d!   Aquest codi s propietat de la Generalitat de
 * ,.W,d##  M#F  ##r ,##2J$.   Catalunya. La seva distribuci est prohibida
 * JJ,4H##  M#F` ##r`,##d3`J   sense el seu consentiment
 * ,N..?M#1.M#F  #HL.w#Y...F
 * .@Ja,:,TWM##1O##NT".?.sJK   2009, Tots els drets reservats
 */
package net.gencat.ctti.canigo.services;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.NotSerializableException;
import java.io.ObjectOutputStream;
import java.util.Enumeration;

import javax.servlet.http.HttpSession;

/**
 * Verifica si els atributs que hi ha a la sessi son serialitzables.
 * Pels atributs serialitzables en calcula el tamany (serialitzat, en bytes) i indica de quina classe son.
 * 
 * Una forma simple d'utilitzar-ho s afegint en una de les pgines (per exemple footer.jsp)
 * 
 * <%
 * new net.gencat.ctti.canigo.services.VerificacioSessioSerialitzable(request.getSession());
 * %>
 *
 * Conv NO utilitzar-ho en un entorn de producci per que la prova realitza la serialitzaci (en memria)
 * de la sessi cada vegada que es cridi a la funci.
 * 
 * @author O.T.Canigo
 *
 */
public final class VerificacioSessioSerialitzable {
	public VerificacioSessioSerialitzable(final HttpSession sessio) {
		Enumeration en = sessio.getAttributeNames();
		System.out.println("\nAtributs de sessi: ");
		int tamanyTotal = 0;
		while (en.hasMoreElements()) {
			String attrName = (String)en.nextElement();
			Object attrVal = sessio.getAttribute(attrName);
			String valClass = attrVal.getClass().getName();
			try {
				int tamanyVal = calculaTamany(attrVal);
				tamanyTotal += tamanyVal;
				System.out.println(" - " + attrName + " (" + valClass + ") - " + tamanyVal);
			} catch (NotSerializableException e) {
				System.out.println(" - " + attrName + " (" + valClass + ") NO SERIALITZABLE");
				//e.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		System.out.println("tamany total dels atributs de la sessi: " + tamanyTotal + "\n");
	}
	
	private final int calculaTamany(Object objecte) throws IOException {
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		ObjectOutputStream oos;
		oos = new ObjectOutputStream(baos);
		oos.writeObject(objecte);
		return baos.size();
	}
}
